/**
* @FileName:	 GameManager.h
* @Programmer	 Brian Hinds
* @Date:         07-02-2017
* @Version:      1.0.2
*/
#pragma once

#include "SetTrekPlugins.h"
#include "Graphics.h"
#include "ImageManager.h"

/// <summary>
/// Class for GameManager
/// This class helps to manages the Game Level
/// </summary>
class GameManager
{
protected:
	/// <summary>
	/// Setting up a graphics object
	/// </summary>
	static Graphics* EngineGFX;
public:
	/// <summary>
	/// This method make it possible to access graphics object
	/// </summary>
	static void Init(Graphics* graphics)
	{
		EngineGFX = graphics;
	}

	bool Loading;
	/// <summary>
	/// Virtual method for the game levels
	/// </summary>
	virtual void Load() = 0;
	virtual void UnLoad() = 0;
	virtual void Render() = 0;
	virtual void Update() = 0;
};