/**
* @FileName:	 Sector01.h
* @Programmer	 Brian Hinds
* @Date:         07-02-2017
* @Version:      1.0.2
*/

#pragma once
#include "GameManager.h"
#include "EventManager.h"
#include "Graphics.h"
#include <stdlib.h>
#include <time.h>
#include<conio.h>

/// <summary>
/// This class manages all the data objects needed
/// for the first level Sector01
/// </summary>
class Sector01 : public GameManager
{
	/// <summary>
	/// Variables for handling game assets position
	/// </summary>
	float StarShip_Y_Position;
	float StarShip_X_Position;
	float NPC_Y_Position;
	float NPC_X_Position;
	float NPCB_Y_Position;
	float NPCB_X_Position;

	float Sector;
	/// <summary>
	/// Variables for handling game assets
	/// </summary>
	ImageManager* BackgroundA;
	ImageManager* BackgroundB;
	ImageManager* BackgroundC;
	ImageManager* BackgroundD;
	ImageManager* BackgroundE;
	ImageManager* BackgroundF;
	ImageManager* BackgroundG;
	ImageManager* PlanetA;
	ImageManager* PlanetB;
	ImageManager* PlanetC;
	ImageManager* PlanetD;
	ImageManager* PlanetE;
	ImageManager* PlanetF;
	ImageManager* PlanetG;
	ImageManager* PlanetH;
	ImageManager* PlanetI;
	ImageManager* PlanetJ;
	ImageManager* ShipStat;
	ImageManager* NPC;
	ImageManager* NPCB;
	ImageManager* ShipHudA;
	ImageManager* ShipHudB;
	ImageManager* ShipHudC;
	ImageManager* DamageA;
	ImageManager* DamageB;
	ImageManager* DamageC;
	ImageManager* DamageD;
	ImageManager* DamageE;
	ImageManager* DamageF;
	ImageManager* Ship;
	ImageManager* ShipRadar;
	ImageManager* Intro;

	/// <summary>
	/// Variables for handling planets positions
	/// </summary>
	float PlanetAPositionX;
	float PlanetAPositionY;
	float PlanetBPositionX;
	float PlanetBPositionY;
	float PlanetCPositionX;
	float PlanetCPositionY;
	int PlanetPoints[2][10];
	int condition;

	/// <summary>
	/// Variable for handling NPCs frame rate
	/// </summary>
	int frame;

	/// <summary>
	/// Variable for handling intro screen
	/// </summary>
	float Splash;

	/// <summary>
	/// Variables for handling ship damage
	/// </summary>
	int hit;

	/// <summary>
	/// Variable for starting the game
	/// </summary>
	bool StartGame;

public:
	/// <summary>
	/// Load game assets and values
	/// </summary>
	void Load()override;

	/// <summary>
	/// Unload assets when level is complete
	/// </summary>
	void UnLoad()override;

	/// <summary>
	/// Updates assets based on condition
	/// </summary>
	void Update()override;

	/// <summary>
	/// Renders current assets update values
	/// </summary>
	void Render()override;

	/// <summary>
	/// Renders event one
	/// </summary>
	void Event01();

	/// <summary>
	/// Determine where each planet will spawn
	/// </summary>
	void Location();

	/// <summary>
	/// Determine what background to render
	/// </summary>
	void SectorBackground();

	/// <summary>
	/// Renders the ship HUD
	/// </summary>
	void SetShipHuds();

	/// <summary>
	/// Renders the NPCs
	/// </summary>
	void GameNPCs();
};